## iortcw 1.50a+dfsg1

=== MP/Makefile ===
#
# iowolfmp Makefile
#
# GNU Make required
#

COMPILE_PLATFORM=$(shell uname | sed -e 's/_.*//' | tr '[:upper:]' '[:lower:]' | sed -e 's/\//_/g')
COMPILE_ARCH=$(shell uname -m | sed -e 's/i.86/x86/' | sed -e 's/^arm.*/arm/')
ARM_VER_CHECK=$(shell uname -m)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e 's/i.86/x86/')
endif

ifndef BUILD_STANDALONE
  BUILD_STANDALONE =
endif
ifndef BUILD_CLIENT
  BUILD_CLIENT     =
endif
ifndef BUILD_SERVER
  BUILD_SERVER     =
endif
ifndef BUILD_UPDATE_SERVER
  BUILD_UPDATE_SERVER     = 0
endif
ifndef BUILD_GAME_SO
  BUILD_GAME_SO    =
endif
ifndef BUILD_GAME_QVM
  BUILD_GAME_QVM   =
endif
ifndef BUILD_BASEGAME
  BUILD_BASEGAME =
endif
ifndef BUILD_RENDERER_REND2
  BUILD_RENDERER_REND2 =
endif
ifndef BUILD_ARCHIVE
  BUILD_ARCHIVE = 0
endif

#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifeq ($(COMPILE_PLATFORM),cygwin)
  PLATFORM=mingw32
endif

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(PLATFORM),mingw32)
  MINGW=1
endif
ifeq ($(PLATFORM),mingw64)
  MINGW=1
endif

ifeq ($(COMPILE_ARCH),i386)
  COMPILE_ARCH=x86
endif
ifeq ($(COMPILE_ARCH),i86pc)
  COMPILE_ARCH=x86
endif

ifeq ($(COMPILE_ARCH),amd64)
  COMPILE_ARCH=x86_64
endif
ifeq ($(COMPILE_ARCH),x64)
  COMPILE_ARCH=x86_64
endif

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifeq ($(COMPILE_ARCH),axp)
  COMPILE_ARCH=alpha
endif

ifeq ($(COMPILE_ARCH),sparc64)
  COMPILE_ARCH=sparc
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

# For historical compatibility reasons on non-windows
# platform output files use i386 instead of x86
ifeq ($(ARCH),x86)
  ifndef MINGW
    FILE_ARCH=i386
  endif
endif

ifndef FILE_ARCH
FILE_ARCH=$(ARCH)
endif
export FILE_ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifndef VERSION
VERSION=1.5a
endif

ifndef CLIENTBIN
  ifdef MINGW
    CLIENTBIN=ioWolfMP
  else
    CLIENTBIN=iowolfmp
  endif
endif

ifndef SERVERBIN
  ifdef MINGW
    SERVERBIN=ioWolfDED
  else
    SERVERBIN=iowolfded
  endif
endif

ifndef BASEGAME
BASEGAME=main
endif

ifndef BASEGAME_CFLAGS
BASEGAME_CFLAGS=
endif

ifndef COPYDIR
COPYDIR="/usr/local/games/wolf"
endif

ifndef COPYBINDIR
COPYBINDIR=$(COPYDIR)
endif

ifndef MOUNT_DIR
MOUNT_DIR=code
endif

ifndef BUILD_DIR
BUILD_DIR=build
endif

ifndef TEMPDIR
TEMPDIR=/tmp
endif

ifndef GENERATE_DEPENDENCIES
GENERATE_DEPENDENCIES=1
endif

ifndef USE_OPENAL
USE_OPENAL=1
endif

ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif

ifndef USE_CURL
USE_CURL=1
endif

ifndef USE_CURL_DLOPEN
  ifdef MINGW
    USE_CURL_DLOPEN=0
  else
    USE_CURL_DLOPEN=1
  endif
endif

ifndef USE_CODEC_VORBIS
USE_CODEC_VORBIS=1
endif

ifndef USE_CODEC_OPUS
USE_CODEC_OPUS=1
endif

ifndef USE_MUMBLE
USE_MUMBLE=1
endif

ifndef USE_VOIP
USE_VOIP=1
endif

ifndef USE_FREETYPE
USE_FREETYPE=1
endif

ifndef USE_INTERNAL_LIBS
USE_INTERNAL_LIBS=1
endif

ifndef USE_INTERNAL_OGG
USE_INTERNAL_OGG=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_VORBIS
USE_INTERNAL_VORBIS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_OPUS
USE_INTERNAL_OPUS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_FREETYPE
USE_INTERNAL_FREETYPE=$(USE_INTERNAL_LIBS)
endif

ifndef USE_LOCAL_HEADERS
USE_LOCAL_HEADERS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=1
endif

ifndef USE_XDG
USE_XDG=0
endif

ifndef USE_YACC
USE_YACC=0
endif

ifndef DEBUG_CFLAGS
DEBUG_CFLAGS=-g -O0
endif

ifndef USE_ANTIWALLHACK
USE_ANTIWALLHACK=1
endif

ifndef USE_BLOOM
USE_BLOOM=1
endif

ifndef USE_OPENGLES
USE_OPENGLES=0
endif

ifndef RASPBERRY_PI
RASPBERRY_PI=0
endif

ifndef USE_PBMD5
USE_PBMD5=1
endif

ifndef USE_AUTHORIZE_SERVER
USE_AUTHORIZE_SERVER=0
endif


#############################################################################

BD=$(BUILD_DIR)/debug-$(PLATFORM)-$(ARCH)
BR=$(BUILD_DIR)/release-$(PLATFORM)-$(ARCH)
CDIR=$(MOUNT_DIR)/client
SDIR=$(MOUNT_DIR)/server
RDIR=$(MOUNT_DIR)/renderer
R2DIR=$(MOUNT_DIR)/rend2
CMDIR=$(MOUNT_DIR)/qcommon
SDLDIR=$(MOUNT_DIR)/sdl
ASMDIR=$(MOUNT_DIR)/asm
SYSDIR=$(MOUNT_DIR)/sys
GDIR=$(MOUNT_DIR)/game
CGDIR=$(MOUNT_DIR)/cgame
BLIBDIR=$(MOUNT_DIR)/botlib
NDIR=$(MOUNT_DIR)/null
UIDIR=$(MOUNT_DIR)/ui
JPDIR=$(MOUNT_DIR)/jpeg-8c
OGGDIR=$(MOUNT_DIR)/libogg-1.3.2
VORBISDIR=$(MOUNT_DIR)/libvorbis-1.3.5
OPUSDIR=$(MOUNT_DIR)/opus-1.1.2
OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.7
ZDIR=$(MOUNT_DIR)/zlib-1.2.8
FTDIR=$(MOUNT_DIR)/freetype-2.6.4
SPLDIR=$(MOUNT_DIR)/splines
Q3ASMDIR=$(MOUNT_DIR)/tools/asm
LBURGDIR=$(MOUNT_DIR)/tools/lcc/lburg
Q3CPPDIR=$(MOUNT_DIR)/tools/lcc/cpp
Q3LCCETCDIR=$(MOUNT_DIR)/tools/lcc/etc
Q3LCCSRCDIR=$(MOUNT_DIR)/tools/lcc/src
SDLHDIR=$(MOUNT_DIR)/SDL2
LIBSDIR=$(MOUNT_DIR)/libs

bin_path=$(shell which $(1) 2> /dev/null)

# We won't need this if we only build the server
ifneq ($(BUILD_CLIENT),0)
  # set PKG_CONFIG_PATH to influence this, e.g.
  # PKG_CONFIG_PATH=/opt/cross/i386-mingw32msvc/lib/pkgconfig
  ifneq ($(call bin_path, pkg-config),)
    CURL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags libcurl)
    CURL_LIBS ?= $(shell pkg-config --silence-errors --libs libcurl)
    OPENAL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags openal)
    OPENAL_LIBS ?= $(shell pkg-config --silence-errors --libs openal)
    SDL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags sdl2|sed 's/-Dmain=SDL_main//')
    SDL_LIBS ?= $(shell pkg-config --silence-errors --libs sdl2)
  else
    # assume they're in the system default paths (no -I or -L needed)
    CURL_LIBS ?= -lcurl
    OPENAL_LIBS ?= -lopenal
  endif
  # Use sdl2-config if all else fails
  ifeq ($(SDL_CFLAGS),)
    ifneq ($(call bin_path, sdl2-config),)
      SDL_CFLAGS ?= $(shell sdl2-config --cflags)
      SDL_LIBS ?= $(shell sdl2-config --libs)
    endif
  endif
endif


#############################################################################
# SETUP AND BUILD -- LINUX
#############################################################################

## Defaults
INSTALL=install
MKDIR=mkdir
EXTRA_FILES=
CLIENT_EXTRA_FILES=

ifneq (,$(findstring "$(COMPILE_PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))
  TOOLS_CFLAGS += -DARCH_STRING=\"$(COMPILE_ARCH)\"
endif

ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))

  BASE_CFLAGS = -Wall -fno-strict-aliasing \
    -pipe -DUSE_ICON -DARCH_STRING=\\\"$(FILE_ARCH)\\\"
  CLIENT_CFLAGS += $(SDL_CFLAGS)

  OPTIMIZEVM = -O3
  OPTIMIZE = $(OPTIMIZEVM) -ffast-math

  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM = -O3
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM = -O3 -march=i586
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
  endif
  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -maltivec
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -maltivec
  endif
  ifeq ($(ARCH),sparc)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
  endif
  ifeq ($(ARCH),sparc64)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
  endif
  ifeq ($(ARCH),alpha)
    # According to http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=410555
    # -ffast-math will cause the client to die with SIGFPE on Alpha
    OPTIMIZE = $(OPTIMIZEVM)
  endif

  SHLIBEXT=so
  SHLIBCFLAGS=-fPIC -fvisibility=hidden
  SHLIBLDFLAGS=-shared $(LDFLAGS)

  THREAD_LIBS=-lpthread
  LIBS=-ldl -lm

  ifeq ($(USE_LOCAL_HEADERS),1)
    CLIENT_CFLAGS += -I$(SDLHDIR)/include
  endif

  ifeq ($(USE_INTERNAL_LIBS),1)
    ifeq ($(CROSS_COMPILING),1)
      ifeq ($(ARCH),x86)
      SDL_LIBS = $(LIBSDIR)/linux32/libSDL2main.a \
                 $(LIBSDIR)/linux32/libSDL2-2.0.so.0.4.0
      endif
      ifeq ($(ARCH),x86_64)
      SDL_LIBS = $(LIBSDIR)/linux64/libSDL2main.a \
                 $(LIBSDIR)/linux64/libSDL2-2.0.so.0.4.0
      endif
    endif
  endif

  ifeq ($(USE_OPENGLES),1)
    ifeq ($(RASPBERRY_PI),1)
      BUILD_RENDERER_REND2 = 0
      BASE_CFLAGS += -DUSE_OPENGLES
      LDFLAGS += -L/opt/vc/lib
      CLIENT_LIBS = $(SDL_LIBS) -lbcm_host
      RENDERER_LIBS = $(SDL_LIBS) -lEGL -lGLESv1_CM -lbcm_host
      SERVER_LIBS = -lbcm_host
    else
      BUILD_RENDERER_REND2 = 0
      BASE_CFLAGS += -DUSE_OPENGLES
      CLIENT_LIBS = $(SDL_LIBS)
      RENDERER_LIBS = $(SDL_LIBS) -lEGL -lGLESv1_CM
      SERVER_LIBS =
    endif
  else
    CLIENT_CFLAGS += $(SDL_CFLAGS)
    CLIENT_LIBS += $(SDL_LIBS)
    RENDERER_LIBS += $(SDL_LIBS) -lGL
    SERVER_LIBS =
  endif

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
    endif
  endif

  ifeq ($(USE_CURL),1)
    CLIENT_CFLAGS += $(CURL_CFLAGS)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += $(CURL_LIBS)
    endif
  endif

  ifeq ($(USE_MUMBLE),1)
    CLIENT_LIBS += -lrt
  endif

else # ifeq Linux

#############################################################################
# SETUP AND BUILD -- MAC OS X
#############################################################################

ifeq ($(PLATFORM),darwin)
  LIBS = -framework Cocoa
  CLIENT_LIBS=
  RENDERER_LIBS=
  OPTIMIZEVM=

  BASE_CFLAGS = -Wall -mmacosx-version-min=10.5 \
    -DMAC_OS_X_VERSION_MIN_REQUIRED=1050

  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -arch ppc -faltivec
    OPTIMIZEVM += -O3
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -arch ppc64 -faltivec
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM += -march=prescott -mfpmath=sse
    # x86 vm will crash without -mstackrealign since MMX instructions will be
    # used no matter what and they corrupt the frame pointer in VM calls
    BASE_CFLAGS += -arch i386 -mstackrealign
  endif
  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM += -arch x86_64 -mfpmath=sse
  endif

  # When compiling on OSX for OSX, we're not cross compiling as far as the
  # Makefile is concerned, as target architecture is specified as a compiler
  # argument
  ifeq ($(COMPILE_PLATFORM),darwin)
    CROSS_COMPILING=0
  endif

  ifeq ($(CROSS_COMPILING),1)
    ifeq ($(ARCH),ppc)
      CC=powerpc-apple-darwin10-gcc
      RANLIB=powerpc-apple-darwin10-ranlib
    else
      ifeq ($(ARCH),x86)
        CC=i686-apple-darwin10-gcc
        RANLIB=i686-apple-darwin10-ranlib
      else
        $(error Architecture $(ARCH) is not supported when cross compiling)
      endif
    endif
  endif

  BASE_CFLAGS += -fno-strict-aliasing -fno-common -pipe

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      ifneq ($(USE_INTERNAL_LIBS),1)
        CLIENT_CFLAGS += $(OPENAL_CFLAGS)
        CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
      else
        CLIENT_LIBS += -framework OpenAL
      endif
    endif
  endif

  ifeq ($(USE_CURL),1)
    CLIENT_CFLAGS += $(CURL_CFLAGS)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += $(CURL_LIBS)
    endif
  endif

  BASE_CFLAGS += -D_THREAD_SAFE=1

  ifeq ($(USE_LOCAL_HEADERS),1)
    CLIENT_CFLAGS += -I$(SDLHDIR)/include
  else
    CLIENT_CFLAGS += $(SDL_CFLAGS)
  endif

  # We copy sdlmain before ranlib'ing it so that subversion doesn't think
  #  the file has been modified by each build.
  ifeq ($(USE_INTERNAL_LIBS),1)
    LIBSDLMAIN=$(B)/libSDL2main.a
    LIBSDLMAINSRC=$(LIBSDIR)/macosx/libSDL2main.a
    CLIENT_LIBS += -framework IOKit $(LIBSDIR)/macosx/libSDL2-2.0.0.dylib

=== SP/Makefile ===
#
# iowolfsp Makefile
#
# GNU Make required
#

COMPILE_PLATFORM=$(shell uname | sed -e 's/_.*//' | tr '[:upper:]' '[:lower:]' | sed -e 's/\//_/g')
COMPILE_ARCH=$(shell uname -m | sed -e 's/i.86/x86/' | sed -e 's/^arm.*/arm/')
ARM_VER_CHECK=$(shell uname -m)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e 's/i.86/x86/')
endif

ifndef BUILD_STANDALONE
  BUILD_STANDALONE =
endif
ifndef BUILD_CLIENT
  BUILD_CLIENT     =
endif
ifndef BUILD_SERVER
  BUILD_SERVER     = 0
endif
ifndef BUILD_GAME_SO
  BUILD_GAME_SO    =
endif
ifndef BUILD_GAME_QVM
  BUILD_GAME_QVM   = 0
endif
ifndef BUILD_BASEGAME
  BUILD_BASEGAME =
endif
ifndef BUILD_RENDERER_REND2
  BUILD_RENDERER_REND2 =
endif
ifndef BUILD_ARCHIVE
  BUILD_ARCHIVE = 0
endif

#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifeq ($(COMPILE_PLATFORM),cygwin)
  PLATFORM=mingw32
endif

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(PLATFORM),mingw32)
  MINGW=1
endif
ifeq ($(PLATFORM),mingw64)
  MINGW=1
endif

ifeq ($(COMPILE_ARCH),i386)
  COMPILE_ARCH=x86
endif
ifeq ($(COMPILE_ARCH),i86pc)
  COMPILE_ARCH=x86
endif

ifeq ($(COMPILE_ARCH),amd64)
  COMPILE_ARCH=x86_64
endif
ifeq ($(COMPILE_ARCH),x64)
  COMPILE_ARCH=x86_64
endif

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifeq ($(COMPILE_ARCH),axp)
  COMPILE_ARCH=alpha
endif

ifeq ($(COMPILE_ARCH),sparc64)
  COMPILE_ARCH=sparc
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

# For historical compatibility reasons on non-windows
# platform output files use i386 instead of x86
ifeq ($(ARCH),x86)
  ifndef MINGW
    FILE_ARCH=i386
  endif
endif

ifndef FILE_ARCH
FILE_ARCH=$(ARCH)
endif
export FILE_ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifndef VERSION
VERSION=1.5a
endif

ifndef CLIENTBIN
 ifdef MINGW
    CLIENTBIN=ioWolfSP
  else
    CLIENTBIN=iowolfsp
  endif
endif

ifndef SERVERBIN
  ifdef MINGW
    SERVERBIN=ioWolfSPDED
  else
    SERVERBIN=iowolfspded
  endif
endif

ifndef BASEGAME
BASEGAME=main
endif

ifndef BASEGAME_CFLAGS
BASEGAME_CFLAGS=
endif

ifndef COPYDIR
COPYDIR="/usr/local/games/wolf"
endif

ifndef COPYBINDIR
COPYBINDIR=$(COPYDIR)
endif

ifndef MOUNT_DIR
MOUNT_DIR=code
endif

ifndef BUILD_DIR
BUILD_DIR=build
endif

ifndef TEMPDIR
TEMPDIR=/tmp
endif

ifndef GENERATE_DEPENDENCIES
GENERATE_DEPENDENCIES=1
endif

ifndef USE_OPENAL
USE_OPENAL=1
endif

ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif

ifndef USE_CURL
USE_CURL=0
endif

ifndef USE_CURL_DLOPEN
  ifdef MINGW
    USE_CURL_DLOPEN=0
  else
    USE_CURL_DLOPEN=1
  endif
endif

ifndef USE_CODEC_VORBIS
USE_CODEC_VORBIS=1
endif

ifndef USE_CODEC_OPUS
USE_CODEC_OPUS=1
endif

ifndef USE_MUMBLE
USE_MUMBLE=1
endif

ifndef USE_VOIP
USE_VOIP=1
endif

ifndef USE_FREETYPE
USE_FREETYPE=1
endif

ifndef USE_INTERNAL_LIBS
USE_INTERNAL_LIBS=1
endif

ifndef USE_INTERNAL_OGG
USE_INTERNAL_OGG=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_VORBIS
USE_INTERNAL_VORBIS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_OPUS
USE_INTERNAL_OPUS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_FREETYPE
USE_INTERNAL_FREETYPE=$(USE_INTERNAL_LIBS)
endif

ifndef USE_LOCAL_HEADERS
USE_LOCAL_HEADERS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=1
endif

ifndef USE_XDG
USE_XDG=0
endif

ifndef USE_YACC
USE_YACC=0
endif

ifndef DEBUG_CFLAGS
DEBUG_CFLAGS=-g -O0
endif

ifndef USE_BLOOM
USE_BLOOM=1
endif

ifndef USE_OPENGLES
USE_OPENGLES=0
endif

ifndef RASPBERRY_PI
RASPBERRY_PI=0
endif

ifndef USE_AUTHORIZE_SERVER
USE_AUTHORIZE_SERVER=0
endif


#############################################################################

BD=$(BUILD_DIR)/debug-$(PLATFORM)-$(ARCH)
BR=$(BUILD_DIR)/release-$(PLATFORM)-$(ARCH)
CDIR=$(MOUNT_DIR)/client
SDIR=$(MOUNT_DIR)/server
RDIR=$(MOUNT_DIR)/renderer
R2DIR=$(MOUNT_DIR)/rend2
CMDIR=$(MOUNT_DIR)/qcommon
SDLDIR=$(MOUNT_DIR)/sdl
ASMDIR=$(MOUNT_DIR)/asm
SYSDIR=$(MOUNT_DIR)/sys
GDIR=$(MOUNT_DIR)/game
CGDIR=$(MOUNT_DIR)/cgame
BLIBDIR=$(MOUNT_DIR)/botlib
NDIR=$(MOUNT_DIR)/null
UIDIR=$(MOUNT_DIR)/ui
JPDIR=$(MOUNT_DIR)/jpeg-8c
OGGDIR=$(MOUNT_DIR)/libogg-1.3.2
VORBISDIR=$(MOUNT_DIR)/libvorbis-1.3.5
OPUSDIR=$(MOUNT_DIR)/opus-1.1.2
OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.7
ZDIR=$(MOUNT_DIR)/zlib-1.2.8
FTDIR=$(MOUNT_DIR)/freetype-2.6.4
SPLDIR=$(MOUNT_DIR)/splines
Q3ASMDIR=$(MOUNT_DIR)/tools/asm
LBURGDIR=$(MOUNT_DIR)/tools/lcc/lburg
Q3CPPDIR=$(MOUNT_DIR)/tools/lcc/cpp
Q3LCCETCDIR=$(MOUNT_DIR)/tools/lcc/etc
Q3LCCSRCDIR=$(MOUNT_DIR)/tools/lcc/src
SDLHDIR=$(MOUNT_DIR)/SDL2
LIBSDIR=$(MOUNT_DIR)/libs

bin_path=$(shell which $(1) 2> /dev/null)

# We won't need this if we only build the server
ifneq ($(BUILD_CLIENT),0)
  # set PKG_CONFIG_PATH to influence this, e.g.
  # PKG_CONFIG_PATH=/opt/cross/i386-mingw32msvc/lib/pkgconfig
  ifneq ($(call bin_path, pkg-config),)
    CURL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags libcurl)
    CURL_LIBS ?= $(shell pkg-config --silence-errors --libs libcurl)
    OPENAL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags openal)
    OPENAL_LIBS ?= $(shell pkg-config --silence-errors --libs openal)
    SDL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags sdl2|sed 's/-Dmain=SDL_main//')
    SDL_LIBS ?= $(shell pkg-config --silence-errors --libs sdl2)
  else
    # assume they're in the system default paths (no -I or -L needed)
    CURL_LIBS ?= -lcurl
    OPENAL_LIBS ?= -lopenal
  endif
  # Use sdl2-config if all else fails
  ifeq ($(SDL_CFLAGS),)
    ifneq ($(call bin_path, sdl2-config),)
      SDL_CFLAGS ?= $(shell sdl2-config --cflags)
      SDL_LIBS ?= $(shell sdl2-config --libs)
    endif
  endif
endif


#############################################################################
# SETUP AND BUILD -- LINUX
#############################################################################

## Defaults
INSTALL=install
MKDIR=mkdir
EXTRA_FILES=
CLIENT_EXTRA_FILES=

ifneq (,$(findstring "$(COMPILE_PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))
  TOOLS_CFLAGS += -DARCH_STRING=\"$(COMPILE_ARCH)\"
endif

ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))

  BASE_CFLAGS = -Wall -fno-strict-aliasing \
    -pipe -DUSE_ICON -DARCH_STRING=\\\"$(FILE_ARCH)\\\"
  CLIENT_CFLAGS += $(SDL_CFLAGS)

  OPTIMIZEVM = -O3
  OPTIMIZE = $(OPTIMIZEVM) -ffast-math

  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM = -O3
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM = -O3 -march=i586
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
  endif
  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -maltivec
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -maltivec
  endif
  ifeq ($(ARCH),sparc)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
  endif
  ifeq ($(ARCH),sparc64)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
  endif
  ifeq ($(ARCH),alpha)
    # According to http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=410555
    # -ffast-math will cause the client to die with SIGFPE on Alpha
    OPTIMIZE = $(OPTIMIZEVM)
  endif

  SHLIBEXT=so
  SHLIBCFLAGS=-fPIC -fvisibility=hidden
  SHLIBLDFLAGS=-shared $(LDFLAGS)

  THREAD_LIBS=-lpthread
  LIBS=-ldl -lm

  ifeq ($(USE_LOCAL_HEADERS),1)
    CLIENT_CFLAGS += -I$(SDLHDIR)/include
  endif

  ifeq ($(USE_INTERNAL_LIBS),1)
    ifeq ($(CROSS_COMPILING),1)
      ifeq ($(ARCH),x86)
      SDL_LIBS = $(LIBSDIR)/linux32/libSDL2main.a \
                 $(LIBSDIR)/linux32/libSDL2-2.0.so.0.4.0
      endif
      ifeq ($(ARCH),x86_64)
      SDL_LIBS = $(LIBSDIR)/linux64/libSDL2main.a \
                 $(LIBSDIR)/linux64/libSDL2-2.0.so.0.4.0
      endif
    endif
  endif

  ifeq ($(USE_OPENGLES),1)
    ifeq ($(RASPBERRY_PI),1)
      BUILD_RENDERER_REND2 = 0
      BASE_CFLAGS += -DUSE_OPENGLES
      LDFLAGS += -L/opt/vc/lib
      CLIENT_LIBS = $(SDL_LIBS) -lbcm_host
      RENDERER_LIBS = $(SDL_LIBS) -lEGL -lGLESv1_CM -lbcm_host
      SERVER_LIBS = -lbcm_host
    else
      BUILD_RENDERER_REND2 = 0
      BASE_CFLAGS += -DUSE_OPENGLES
      CLIENT_LIBS = $(SDL_LIBS)
      RENDERER_LIBS = $(SDL_LIBS) -lEGL -lGLESv1_CM
      SERVER_LIBS =
    endif
  else
    CLIENT_CFLAGS += $(SDL_CFLAGS)
    CLIENT_LIBS += $(SDL_LIBS)
    RENDERER_LIBS += $(SDL_LIBS) -lGL
    SERVER_LIBS =
  endif

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
    endif
  endif

  ifeq ($(USE_CURL),1)
    CLIENT_CFLAGS += $(CURL_CFLAGS)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += $(CURL_LIBS)
    endif
  endif

  ifeq ($(USE_MUMBLE),1)
    CLIENT_LIBS += -lrt
  endif

else # ifeq Linux

#############################################################################
# SETUP AND BUILD -- MAC OS X
#############################################################################

ifeq ($(PLATFORM),darwin)
  LIBS = -framework Cocoa
  CLIENT_LIBS=
  RENDERER_LIBS=
  OPTIMIZEVM=

  BASE_CFLAGS = -Wall -mmacosx-version-min=10.5 \
    -DMAC_OS_X_VERSION_MIN_REQUIRED=1050

  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -arch ppc -faltivec
    OPTIMIZEVM += -O3
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -arch ppc64 -faltivec
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM += -march=prescott -mfpmath=sse
    # x86 vm will crash without -mstackrealign since MMX instructions will be
    # used no matter what and they corrupt the frame pointer in VM calls
    BASE_CFLAGS += -arch i386 -mstackrealign
  endif
  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM += -arch x86_64 -mfpmath=sse
  endif

  # When compiling on OSX for OSX, we're not cross compiling as far as the
  # Makefile is concerned, as target architecture is specified as a compiler
  # argument
  ifeq ($(COMPILE_PLATFORM),darwin)
    CROSS_COMPILING=0
  endif

  ifeq ($(CROSS_COMPILING),1)
    ifeq ($(ARCH),ppc)
      CC=powerpc-apple-darwin10-gcc
      RANLIB=powerpc-apple-darwin10-ranlib
    else
      ifeq ($(ARCH),x86)
        CC=i686-apple-darwin10-gcc
        RANLIB=i686-apple-darwin10-ranlib
      else
        $(error Architecture $(ARCH) is not supported when cross compiling)
      endif
    endif
  endif

  BASE_CFLAGS += -fno-strict-aliasing -fno-common -pipe

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      ifneq ($(USE_INTERNAL_LIBS),1)
        CLIENT_CFLAGS += $(OPENAL_CFLAGS)
        CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
      else
        CLIENT_LIBS += -framework OpenAL
      endif
    endif
  endif

  ifeq ($(USE_CURL),1)
    CLIENT_CFLAGS += $(CURL_CFLAGS)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += $(CURL_LIBS)
    endif
  endif

  BASE_CFLAGS += -D_THREAD_SAFE=1

  ifeq ($(USE_LOCAL_HEADERS),1)
    CLIENT_CFLAGS += -I$(SDLHDIR)/include
  else
    CLIENT_CFLAGS += $(SDL_CFLAGS)
  endif

  # We copy sdlmain before ranlib'ing it so that subversion doesn't think
  #  the file has been modified by each build.
  ifeq ($(USE_INTERNAL_LIBS),1)
    LIBSDLMAIN=$(B)/libSDL2main.a
    LIBSDLMAINSRC=$(LIBSDIR)/macosx/libSDL2main.a
    CLIENT_LIBS += -framework IOKit $(LIBSDIR)/macosx/libSDL2-2.0.0.dylib
    RENDERER_LIBS += -framework OpenGL $(LIBSDIR)/macosx/libSDL2-2.0.0.dylib
  else
    CLIENT_LIBS += -framework IOKit $(SDL_LIBS)

=== debian/changelog ===
iortcw (1.50a+dfsg1-3+deb9u1) stretch-security; urgency=medium

  * d/p/security/All-Fix-improve-buffer-overflow-in-MSG_ReadBits-MSG_Write.patch:
    Add patch (from ioquake3 via upstream) to fix a read buffer overflow
    in MSG_ReadBits (CVE-2017-11721)

 -- Simon McVittie <smcv@debian.org>  Tue, 08 Aug 2017 14:57:52 -0400

iortcw (1.50a+dfsg1-3) unstable; urgency=high

  * d/gbp.conf: switch branch to debian/stretch for updates during freeze
  * d/patches: Add patches from upstream fixing security vulnerabilities
    - refuse to load potentially auto-downloadable .pk3 files as
      iortcw renderers, iortcw game code, libcurl, or OpenAL drivers
      (mitigation: auto-downloading is off by default, and in Debian
      we do not dlopen libcurl anyway)
    - refuse to load default configuration file names from a .pk3 file
    - protect cl_renderer, cl_curllib, s_aldriver configuration variables so
      game code cannot set them
    - refuse to overwrite files other than *.txt with the dump console
      command
    - refuse to overwrite files other than *.cfg with the writeconfig
      console command
    (Closes: #857714)

 -- Simon McVittie <smcv@debian.org>  Tue, 14 Mar 2017 09:37:19 +0000

iortcw (1.50a+dfsg1-2) unstable; urgency=medium

  * Drop unused libspeexdsp-dev build-dependency
    (VoIP is now done using the Opus codec)
  * debian/watch: strip +dfsg1 suffix when comparing versions even if
    working from a release and not a datestamped snapshot
  * debian/apparmor.d: allow more forms of device enumeration

 -- Simon McVittie <smcv@debian.org>  Sat, 21 Jan 2017 20:25:48 +0000

iortcw (1.50a+dfsg1-1) unstable; urgency=medium

  * New upstream release 1.5a, represented as 1.50a here to make it
    sort in the intended order
    - drop patches that were merged upstream
    - debian/copyright: update
  * d/p/Don-t-require-.git-index-to-exist.patch: Fix FTBFS when
    .git/index doesn't exist

 -- Simon McVittie <smcv@debian.org>  Sun, 20 Nov 2016 22:27:56 +0000

iortcw (1.42d+dfsg1-5) unstable; urgency=medium

  * Fix date(1) syntax when using SOURCE_DATE_EPOCH
  * Mark patches as applied upstream or Debian-specific, as
    appropriate
  * Always do a "release" build. Override OPTIMIZE to empty instead of
    using upstream's "debug" build for noopt.
  * Use upstream's copyfiles (install) target instead of reimplementing it
  * Write generated scripts directly into debian/tmp/usr/games
  * Add missing dependency on lsb-base, detected by lintian
  * Sync AppArmor profile with ioquake3

 -- Simon McVittie <smcv@debian.org>  Sat, 05 Nov 2016 22:36:05 +0000

iortcw (1.42d+dfsg1-4) unstable; urgency=medium

  * Normalize packaging via wrap-and-sort -abst
  * debian/gbp.conf: use DEP-14 branch names debian/master, upstream/latest
  * Remove rtcw-dbg binary package and rely on automatic dbgsym packages
  * debian/rules: improve get-orig-source target
  * Bump debhelper compat level to 10
    - don't explicitly use dh-systemd, it is now integrated
    - don't explicitly do a parallel build, it is the default
  * debian/rules: align with ioquake3's (cosmetic changes only)

 -- Simon McVittie <smcv@debian.org>  Wed, 21 Sep 2016 20:10:00 +0100

=== debian/control ===
Source: iortcw
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Simon McVittie <smcv@debian.org>,
Build-Depends:
 debhelper (>= 10),
 dh-apparmor [linux-any],
 dpkg-dev (>= 1.16.1),
 libcurl4-gnutls-dev,
 libfreetype6-dev,
 libjpeg-dev,
 libopenal-dev,
 libopus-dev,
 libopusfile-dev,
 libsdl2-dev (>= 2.0.0),
 libvorbis-dev,
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-games/iortcw.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/iortcw.git
Homepage: https://github.com/iortcw/iortcw/

Package: rtcw
Architecture: any
Depends:
 rtcw-common (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 x11-utils | zenity | kde-baseapps-bin,
Description: game engine for Return to Castle Wolfenstein
 Return to Castle Wolfenstein is a military- and occult-themed first-person
 shooter game in a Second World War setting, originally released in 2001.
 It is a sequel to Wolfenstein 3D, which is also available for Debian
 (in the wolf4sdl package).
 .
 This package contains the iortcw game engines for the single-player campaign
 and multiplayer, based on ioquake3 and the GPL source releases of RTCW.
 .
 For security reasons, this version has been modified to prevent native
 executable code from being unpacked from game packages (PK3 files).
 Some game modifications will not work as a result of this change.
 .
 Return to Castle Wolfenstein requires non-distributable game data files
 in the rtcw-data package, prepared using the game-data-packager tool.

Package: rtcw-common
Architecture: any
Depends:
 rtcw-data (>= 1.42b+40) | game-data-packager (>= 40),
 ${misc:Depends},
 ${shlibs:Depends},
Description: common files for Return to Castle Wolfenstein
 Return to Castle Wolfenstein is a military- and occult-themed first-person
 shooter game in a Second World War setting, originally released in 2001.
 It is a sequel to Wolfenstein 3D, which is also available for Debian
 (in the wolf4sdl package).
 .
 This package contains files shared by the game and the dedicated server.
 It requires non-distributable game data files from the rtcw-data package,
 which can be prepared using the game-data-packager tool.

Package: rtcw-server
Architecture: any
Depends:
 adduser,
 lsb-base (>= 3.0-6~),
 rtcw-common (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: standalone server for Return to Castle Wolfenstein
 Return to Castle Wolfenstein is a military- and occult-themed first-person
 shooter game in a Second World War setting, originally released in 2001.
 It is a sequel to Wolfenstein 3D, which is also available for Debian
 (in the wolf4sdl package).
 .
 This package contains the iortcw dedicated server for multiplayer,
 based on ioquake3 and the GPL source releases of RTCW. It also contains
 the init script and systemd unit to start the RTCW server, with support
 for multiple server instances under systemd.
 .
 Return to Castle Wolfenstein requires non-distributable game data files
 from the rtcw-data package, prepared using the game-data-packager tool.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_CFLAGS_MAINT_APPEND := \
	-fsigned-char \
	$(NULL)

include /usr/share/dpkg/default.mk

%:
	dh $@

options := \
	V=1 \
	USE_CODEC_OPUS=1 \
	USE_CODEC_VORBIS=1 \
	USE_CURL=1 \
	USE_CURL_DLOPEN=0 \
	USE_INTERNAL_LIBS=0 \
	USE_LOCAL_HEADERS=0 \
	USE_OPENAL=1 \
	USE_OPENAL_DLOPEN=0 \
	USE_VOIP=1 \
	$(shell debian/q3arch make ${DEB_HOST_GNU_CPU} ${DEB_HOST_GNU_SYSTEM}) \
	BUILD_GAME_QVM=0 \
	COPYDIR=$(CURDIR)/debian/tmp/usr/lib/rtcw \
	NO_STRIP=1 \
	OPTIMIZE='' \
	VERSION=$(DEB_VERSION)/$(DEB_VENDOR) \
	CFLAGS='$(filter-out -fPIE -pie,$(CFLAGS)) $(CPPFLAGS)' \
	NOTSHLIBCFLAGS='$(filter -fPIE -pie,$(CFLAGS))' \
	LDFLAGS='$(filter-out -fPIE -pie,$(LDFLAGS))' \
	NOTSHLIBLDFLAGS='$(filter -fPIE -pie,$(LDFLAGS))' \
	$(NULL)

sp_options := \
	BR=$(CURDIR)/debian/build/sp \
	$(NULL)

mp_options := \
	BR=$(CURDIR)/debian/build/mp \
	$(NULL)

ifeq ($(DEB_HOST_ARCH),armhf)
options += ARM_VER_CHECK=armv7l
else
options += ARM_VER_CHECK=something_else
endif

override_dh_auto_build:
	install -d debian/build/mp debian/build/sp
	make -C SP -- \
		$(options) \
		$(sp_options) \
		release
	make -C MP -- \
		$(options) \
		$(mp_options) \
		release

override_dh_auto_install:
	make -C SP -- \
		$(options) \
		$(sp_options) \
		copyfiles
	cd debian/tmp/usr/lib/rtcw && ln -s iowolfsp.* iowolfsp
	make -C MP -- \
		$(options) \
		$(mp_options) \
		copyfiles
	cd debian/tmp/usr/lib/rtcw && ln -s iowolfmp.* iowolfmp
	cd debian/tmp/usr/lib/rtcw && ln -s iowolfded.* iowolfded
	install -d debian/tmp/usr/games
	sed \
		-e 's!@IOQ3BINARY@!iowolfsp!' \
		-e 's!@IOQ3SELF@!wolfsp!' \
		-e 's!@IOQ3ROLE@!single-player!' \
		< debian/scripts/rtcw.in > debian/tmp/usr/games/wolfsp
	sed \
		-e 's!@IOQ3BINARY@!iowolfmp!' \
		-e 's!@IOQ3SELF@!wolfmp!' \
		-e 's!@IOQ3ROLE@!multiplayer!' \
		< debian/scripts/rtcw.in > debian/tmp/usr/games/wolfmp
	sed \
		-e 's!@IOQ3BINARY@!iowolfded!' \
		-e 's!@IOQ3SELF@!wolfded!' \
		-e 's!@IOQ3ROLE@!multiplayer server!' \
		< debian/scripts/rtcw.in > debian/tmp/usr/games/wolfded
	chmod +x debian/tmp/usr/games/*

ifeq ($(DEB_HOST_ARCH_OS),linux)
override_dh_install-arch:
	dh_install -a
	dh_apparmor -prtcw --profile-name=usr.lib.rtcw
	dh_apparmor -prtcw-server --profile-name=usr.lib.rtcw.iowolfded
endif

override_dh_strip:
	dh_strip --ddeb-migration='rtcw-dbg (<< 1.42d+dfsg1-4~)'

override_dh_clean:
	dh_clean -XSP/code/game/g_func_decs.h.orig -XSP/code/game/g_funcs.h.orig

override_dh_auto_clean:
	make -C SP -- $(options) $(sp_options) clean
	make -C MP -- $(options) $(mp_options) clean
	find debian/build || :
	rm -fr debian/build

# ---------------------------------------------------------------------------

# Not done automatically to avoid a build-dependency on inkscape
maintainer-update-icons: \
		debian/32/wolfsp.png \
		debian/48/wolfsp.png \
		debian/32/wolfmp.png \
		debian/48/wolfmp.png \
		$(NULL)
	inkscape -C -w 32 -h 32 --export-png=debian/32/wolfsp.png debian/wolfsp.svg
	inkscape -C -w 48 -h 48 --export-png=debian/48/wolfsp.png debian/wolfsp.svg
	inkscape -C -w 32 -h 32 --export-png=debian/32/wolfmp.png debian/wolfmp.svg
	inkscape -C -w 48 -h 48 --export-png=debian/48/wolfmp.png debian/wolfmp.svg

ORIG_SOURCE = iortcw
ORIG_REPO ?= https://github.com/iortcw/iortcw
ORIG_REL = 1.50a
ORIG_REV = 1.5a
ORIG_DATE =
ORIG_SUFFIX = +dfsg1

ORIG_EXPORT := ${ORIG_REV}

ifeq (${ORIG_DATE},)
	ORIG_VER := ${ORIG_REL}${ORIG_SUFFIX}
else
	ORIG_VER := ${ORIG_REL}+${ORIG_DATE}${ORIG_SUFFIX}
endif

get-orig-source:
	git clone --bare --depth=1 ${ORIG_REPO} ${ORIG_SOURCE}-${ORIG_VER}.git
	GIT_DIR=${ORIG_SOURCE}-${ORIG_VER}.git git fetch ${ORIG_REPO} ${ORIG_EXPORT}
	GIT_DIR=${ORIG_SOURCE}-${ORIG_VER}.git git archive \
		--format=tar \
		--prefix=${ORIG_SOURCE}-${ORIG_VER}.orig/ \
		${ORIG_EXPORT} | tar -xf-
	test -e ${ORIG_SOURCE}-${ORIG_VER}.orig/MP/COPYING.txt || wget -O ${ORIG_SOURCE}-${ORIG_VER}.orig/MP/COPYING.txt https://raw.githubusercontent.com/id-Software/RTCW-MP/master/COPYING.txt
	test -e ${ORIG_SOURCE}-${ORIG_VER}.orig/SP/COPYING.txt || wget -O ${ORIG_SOURCE}-${ORIG_VER}.orig/SP/COPYING.txt https://raw.githubusercontent.com/id-Software/RTCW-SP/master/COPYING.txt
	: # if in the Debian checkout, check that they haven't changed
	if [ -e debian/rtcw.install ]; then \
		e=0; \
		diff -u MP/COPYING.txt ${ORIG_SOURCE}-${ORIG_VER}.orig/MP/COPYING.txt || e=$$?; \
		diff -u SP/COPYING.txt ${ORIG_SOURCE}-${ORIG_VER}.orig/SP/COPYING.txt || e=$$?; \
		exit $$e; \
	fi
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/AL
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/SDL2
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/curl-*
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/freetype-*
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/jpeg-*
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/libcurl-*
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/libogg-*
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/libs
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/libvorbis-*
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/opus-*
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/opusfile-*
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/tools/lcc
	# Preserve ioapi.? and unzip.? (minizip) because they've been modified
	# to use the idTech3 memory-pool implementation, to avoid leaks when
	# loading a level is aborted. Delete the rest of zlib
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/adler32.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/crc32.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/crypt.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/gzguts.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/inffast.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/inffixed.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/inflate.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/inftrees.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/zconf.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/zlib.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/zlib-*/zutil.?
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/media
	tar --xz -cvf ${ORIG_SOURCE}_${ORIG_VER}.orig.tar.xz ${ORIG_SOURCE}-${ORIG_VER}.orig
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig
	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.git

# to be invoked from a git checkout with upstream github as a remote;
# tarball ends up in ../build-area/
maintainer-get-orig-source:
	$(MAKE) -f debian/rules get-orig-source ORIG_REPO=$$(pwd)/.git
	mv -i -v ${ORIG_SOURCE}_${ORIG_VER}.orig.tar.xz ../build-area/
	@echo "try using:"
	@echo "gbp import-orig ../build-area/${ORIG_SOURCE}_${ORIG_VER}.orig.tar.xz"

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/(\d\S*)\.tar\.gz/iortcw-$1\.tar\.gz/,uversionmangle=s/^(\d+\.\d)([a-z])$/${1}0${2}/,dversionmangle=s/(\+[0-9]{8})?\+dfsg[0-9]+$//" \
  https://github.com/iortcw/iortcw/tags .*/(\d\S*)\.tar\.gz

## iortcw 1.51+dfsg1

=== MP/Makefile ===
--- 
+++ 
@@ -126,7 +126,7 @@
 export CROSS_COMPILING
 
 ifndef VERSION
-VERSION=1.5a
+VERSION=1.51-MP
 endif
 
 ifndef CLIENTBIN
@@ -198,7 +198,7 @@
 endif
 
 ifndef USE_CODEC_VORBIS
-USE_CODEC_VORBIS=1
+USE_CODEC_VORBIS=0
 endif
 
 ifndef USE_CODEC_OPUS
@@ -266,7 +266,7 @@
 endif
 
 ifndef USE_ANTIWALLHACK
-USE_ANTIWALLHACK=1
+USE_ANTIWALLHACK=0
 endif
 
 ifndef USE_BLOOM
@@ -310,9 +310,9 @@
 JPDIR=$(MOUNT_DIR)/jpeg-8c
 OGGDIR=$(MOUNT_DIR)/libogg-1.3.2
 VORBISDIR=$(MOUNT_DIR)/libvorbis-1.3.5
-OPUSDIR=$(MOUNT_DIR)/opus-1.1.2
-OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.7
-ZDIR=$(MOUNT_DIR)/zlib-1.2.8
+OPUSDIR=$(MOUNT_DIR)/opus-1.1.4
+OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.8
+ZDIR=$(MOUNT_DIR)/zlib-1.2.11
 FTDIR=$(MOUNT_DIR)/freetype-2.6.4
 SPLDIR=$(MOUNT_DIR)/splines
 Q3ASMDIR=$(MOUNT_DIR)/tools/asm
@@ -417,11 +417,11 @@
     ifeq ($(CROSS_COMPILING),1)
       ifeq ($(ARCH),x86)
       SDL_LIBS = $(LIBSDIR)/linux32/libSDL2main.a \
-                 $(LIBSDIR)/linux32/libSDL2-2.0.so.0.4.0
+                 $(LIBSDIR)/linux32/libSDL2-2.0.so.0.4.1
       endif
       ifeq ($(ARCH),x86_64)
       SDL_LIBS = $(LIBSDIR)/linux64/libSDL2main.a \
-                 $(LIBSDIR)/linux64/libSDL2-2.0.so.0.4.0
+                 $(LIBSDIR)/linux64/libSDL2-2.0.so.0.4.1
       endif
     endif
   endif

=== SP/Makefile ===
--- 
+++ 
@@ -123,7 +123,7 @@
 export CROSS_COMPILING
 
 ifndef VERSION
-VERSION=1.5a
+VERSION=1.51-SP
 endif
 
 ifndef CLIENTBIN
@@ -195,7 +195,7 @@
 endif
 
 ifndef USE_CODEC_VORBIS
-USE_CODEC_VORBIS=1
+USE_CODEC_VORBIS=0
 endif
 
 ifndef USE_CODEC_OPUS
@@ -299,9 +299,9 @@
 JPDIR=$(MOUNT_DIR)/jpeg-8c
 OGGDIR=$(MOUNT_DIR)/libogg-1.3.2
 VORBISDIR=$(MOUNT_DIR)/libvorbis-1.3.5
-OPUSDIR=$(MOUNT_DIR)/opus-1.1.2
-OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.7
-ZDIR=$(MOUNT_DIR)/zlib-1.2.8
+OPUSDIR=$(MOUNT_DIR)/opus-1.1.4
+OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.8
+ZDIR=$(MOUNT_DIR)/zlib-1.2.11
 FTDIR=$(MOUNT_DIR)/freetype-2.6.4
 SPLDIR=$(MOUNT_DIR)/splines
 Q3ASMDIR=$(MOUNT_DIR)/tools/asm
@@ -406,11 +406,11 @@
     ifeq ($(CROSS_COMPILING),1)
       ifeq ($(ARCH),x86)
       SDL_LIBS = $(LIBSDIR)/linux32/libSDL2main.a \
-                 $(LIBSDIR)/linux32/libSDL2-2.0.so.0.4.0
+                 $(LIBSDIR)/linux32/libSDL2-2.0.so.0.4.1
       endif
       ifeq ($(ARCH),x86_64)
       SDL_LIBS = $(LIBSDIR)/linux64/libSDL2main.a \
-                 $(LIBSDIR)/linux64/libSDL2-2.0.so.0.4.0
+                 $(LIBSDIR)/linux64/libSDL2-2.0.so.0.4.1
       endif
     endif
   endif

=== debian/changelog ===
iortcw (1.51+dfsg1-3) unstable; urgency=medium

  * d/p/1.52/All-Fix-improve-buffer-overflow-in-MSG_ReadBits-MSG_Write.patch:
    Add patch (from ioquake3 via upstream) to fix a read buffer overflow
    in MSG_ReadBits (CVE-2017-11721)

 -- Simon McVittie <smcv@debian.org>  Sat, 05 Aug 2017 11:56:31 +0100

iortcw (1.51+dfsg1-2) unstable; urgency=medium

  * d/copyright, d/rules: Update to reflect addition of COPYING.txt
    to the upstream repository (the license remains the same)
  * d/apparmor.d: Allow even more device enumeration
  * Declare compliance with Debian Policy 4.0.0

 -- Simon McVittie <smcv@debian.org>  Mon, 24 Jul 2017 07:40:19 +0100

iortcw (1.51+dfsg1-1) unstable; urgency=medium

  * Reference CVE-2017-6903 in previous changelog entry
  * Reset git branch to debian/master
  * New upstream release
    - drop patches that came from upstream
  * d/copyright: Fix format declaration
  * AppArmor: Allow reading OpenAL static data files

 -- Simon McVittie <smcv@debian.org>  Thu, 15 Jun 2017 11:33:12 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  libopusfile-dev,
  libsdl2-dev (>= 2.0.0),
  libvorbis-dev,
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/iortcw.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/iortcw.git
 Homepage: https://github.com/iortcw/iortcw/

=== debian/rules ===
--- 
+++ 
@@ -125,8 +125,8 @@
 
 ORIG_SOURCE = iortcw
 ORIG_REPO ?= https://github.com/iortcw/iortcw
-ORIG_REL = 1.50a
-ORIG_REV = 1.5a
+ORIG_REL = 1.51
+ORIG_REV = $(ORIG_REL)
 ORIG_DATE =
 ORIG_SUFFIX = +dfsg1
 
@@ -145,15 +145,8 @@
 		--format=tar \
 		--prefix=${ORIG_SOURCE}-${ORIG_VER}.orig/ \
 		${ORIG_EXPORT} | tar -xf-
-	test -e ${ORIG_SOURCE}-${ORIG_VER}.orig/MP/COPYING.txt || wget -O ${ORIG_SOURCE}-${ORIG_VER}.orig/MP/COPYING.txt https://raw.githubusercontent.com/id-Software/RTCW-MP/master/COPYING.txt
-	test -e ${ORIG_SOURCE}-${ORIG_VER}.orig/SP/COPYING.txt || wget -O ${ORIG_SOURCE}-${ORIG_VER}.orig/SP/COPYING.txt https://raw.githubusercontent.com/id-Software/RTCW-SP/master/COPYING.txt
-	: # if in the Debian checkout, check that they haven't changed
-	if [ -e debian/rtcw.install ]; then \
-		e=0; \
-		diff -u MP/COPYING.txt ${ORIG_SOURCE}-${ORIG_VER}.orig/MP/COPYING.txt || e=$$?; \
-		diff -u SP/COPYING.txt ${ORIG_SOURCE}-${ORIG_VER}.orig/SP/COPYING.txt || e=$$?; \
-		exit $$e; \
-	fi
+	test -e ${ORIG_SOURCE}-${ORIG_VER}.orig/MP/COPYING.txt
+	test -e ${ORIG_SOURCE}-${ORIG_VER}.orig/SP/COPYING.txt
 	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/AL
 	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/SDL2
 	rm -rf ${ORIG_SOURCE}-${ORIG_VER}.orig/*/code/curl-*

## iortcw 1.51.b+dfsg1

=== MP/Makefile ===
--- 
+++ 
@@ -126,7 +126,7 @@
 export CROSS_COMPILING
 
 ifndef VERSION
-VERSION=1.51-MP
+VERSION=1.51b-MP
 endif
 
 ifndef CLIENTBIN
@@ -266,7 +266,7 @@
 endif
 
 ifndef USE_ANTIWALLHACK
-USE_ANTIWALLHACK=0
+USE_ANTIWALLHACK=1
 endif
 
 ifndef USE_BLOOM

=== SP/Makefile ===
--- 
+++ 
@@ -123,7 +123,7 @@
 export CROSS_COMPILING
 
 ifndef VERSION
-VERSION=1.51-SP
+VERSION=1.51b-SP
 endif
 
 ifndef CLIENTBIN

=== debian/changelog ===
iortcw (1.51.b+dfsg1-3) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.1.3
  * Replace kde-baseapps-bin dependency with kdialog (see #885839)
  * AppArmor: Use <abstractions/wayland> from apparmor (>= 2.10.95-5)
    instead of reinventing it
  * AppArmor: Allow reading EGL vendor configuration
  * AppArmor: Allow zenity to read from dconf
  * Move packaging to salsa.debian.org
  * AppArmor: Remove rules for OpenAL static data files, which are now
    allowed by <abstractions/audio> (#874665 in apparmor)

 -- Simon McVittie <smcv@debian.org>  Mon, 15 Jan 2018 09:26:05 +0000

iortcw (1.51.b+dfsg1-2) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.1.1
  * Set Rules-Requires-Root to no

 -- Simon McVittie <smcv@debian.org>  Mon, 06 Nov 2017 10:19:01 +0000

iortcw (1.51.b+dfsg1-1) unstable; urgency=medium

  * New upstream release
    - Drop patch from previous version, now upstream
  * Declare compliance with Debian Policy 4.1.0
  * d/watch: Mangle version number so the trailing "b" is not considered
    to be less than +dfsg

 -- Simon McVittie <smcv@debian.org>  Fri, 08 Sep 2017 11:18:04 +0100

=== debian/control ===
--- 
+++ 
@@ -16,9 +16,10 @@
  libopusfile-dev,
  libsdl2-dev (>= 2.0.0),
  libvorbis-dev,
-Standards-Version: 4.0.0
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/iortcw.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/iortcw.git
+Rules-Requires-Root: no
+Standards-Version: 4.1.3
+Vcs-Git: https://salsa.debian.org/games-team/iortcw.git
+Vcs-Browser: https://salsa.debian.org/games-team/iortcw
 Homepage: https://github.com/iortcw/iortcw/
 
 Package: rtcw
@@ -28,7 +29,9 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
- x11-utils | zenity | kde-baseapps-bin,
+ x11-utils | zenity | kdialog,
+Breaks:
+ apparmor (<< 2.10.95-5~),
 Description: game engine for Return to Castle Wolfenstein
  Return to Castle Wolfenstein is a military- and occult-themed first-person
  shooter game in a Second World War setting, originally released in 2001.

=== debian/rules ===
--- 
+++ 
@@ -125,8 +125,8 @@
 
 ORIG_SOURCE = iortcw
 ORIG_REPO ?= https://github.com/iortcw/iortcw
-ORIG_REL = 1.51
-ORIG_REV = $(ORIG_REL)
+ORIG_REL = 1.51.b
+ORIG_REV = 1.51b
 ORIG_DATE =
 ORIG_SUFFIX = +dfsg1

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/(\d\S*)\.tar\.gz/iortcw-$1\.tar\.gz/,uversionmangle=s/^(\d+\.\d)([a-z])$/${1}0${2}/;s/^([0-9.]+)([a-z])$/${1}.${2}/,dversionmangle=s/(\+[0-9]{8})?\+dfsg[0-9]+$//" \
  https://github.com/iortcw/iortcw/tags .*/(\d\S*)\.tar\.gz
